// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: action.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ActionClient is the client API for Action service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ActionClient interface {
	Create(ctx context.Context, in *ActionModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *ActionModel, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ActionModel, error)
	List(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (Action_ListClient, error)
	Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error)
}

type actionClient struct {
	cc grpc.ClientConnInterface
}

func NewActionClient(cc grpc.ClientConnInterface) ActionClient {
	return &actionClient{cc}
}

func (c *actionClient) Create(ctx context.Context, in *ActionModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.Action/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *actionClient) Update(ctx context.Context, in *ActionModel, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.Action/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *actionClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.Action/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *actionClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ActionModel, error) {
	out := new(ActionModel)
	err := c.cc.Invoke(ctx, "/botMs.Action/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *actionClient) List(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (Action_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &Action_ServiceDesc.Streams[0], "/botMs.Action/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &actionListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Action_ListClient interface {
	Recv() (*ActionModel, error)
	grpc.ClientStream
}

type actionListClient struct {
	grpc.ClientStream
}

func (x *actionListClient) Recv() (*ActionModel, error) {
	m := new(ActionModel)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *actionClient) Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error) {
	out := new(proto.UInt64Value)
	err := c.cc.Invoke(ctx, "/botMs.Action/Count", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ActionServer is the server API for Action service.
// All implementations must embed UnimplementedActionServer
// for forward compatibility
type ActionServer interface {
	Create(context.Context, *ActionModel) (*proto.IdRequest, error)
	Update(context.Context, *ActionModel) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*ActionModel, error)
	List(*emptypb.Empty, Action_ListServer) error
	Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error)
	mustEmbedUnimplementedActionServer()
}

// UnimplementedActionServer must be embedded to have forward compatible implementations.
type UnimplementedActionServer struct {
}

func (UnimplementedActionServer) Create(context.Context, *ActionModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedActionServer) Update(context.Context, *ActionModel) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedActionServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedActionServer) Get(context.Context, *proto.IdRequest) (*ActionModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedActionServer) List(*emptypb.Empty, Action_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedActionServer) Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Count not implemented")
}
func (UnimplementedActionServer) mustEmbedUnimplementedActionServer() {}

// UnsafeActionServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ActionServer will
// result in compilation errors.
type UnsafeActionServer interface {
	mustEmbedUnimplementedActionServer()
}

func RegisterActionServer(s grpc.ServiceRegistrar, srv ActionServer) {
	s.RegisterService(&Action_ServiceDesc, srv)
}

func _Action_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ActionModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ActionServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Action/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ActionServer).Create(ctx, req.(*ActionModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Action_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ActionModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ActionServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Action/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ActionServer).Update(ctx, req.(*ActionModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Action_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ActionServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Action/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ActionServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Action_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ActionServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Action/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ActionServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Action_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(emptypb.Empty)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ActionServer).List(m, &actionListServer{stream})
}

type Action_ListServer interface {
	Send(*ActionModel) error
	grpc.ServerStream
}

type actionListServer struct {
	grpc.ServerStream
}

func (x *actionListServer) Send(m *ActionModel) error {
	return x.ServerStream.SendMsg(m)
}

func _Action_Count_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ActionServer).Count(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Action/Count",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ActionServer).Count(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Action_ServiceDesc is the grpc.ServiceDesc for Action service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Action_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.Action",
	HandlerType: (*ActionServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Action_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Action_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Action_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _Action_Get_Handler,
		},
		{
			MethodName: "Count",
			Handler:    _Action_Count_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _Action_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "action.proto",
}
